// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERBASEMM_AUDIOFILTER_H
#define _GSTREAMERBASEMM_AUDIOFILTER_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gstreamermm/basetransform.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstAudioFilter GstAudioFilter;
typedef struct _GstAudioFilterClass GstAudioFilterClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace GstBase
{ class AudioFilter_Class; } // namespace GstBase
namespace GstBase
{

/** GstBase::AudioFilter — Base class for simple audio filters.
 * GstBase::AudioFilter is a Gst::BaseTransform-derived base class for simple
 * audio filters, ie. those that output the same format that they get as input.
 *
 * GstBase::AudioFilter will parse the input format for you (with error
 * checking) before calling your setup function. Also, elements deriving from
 * GstBase::AudioFilter may use gst_audio_filter_class_add_pad_templates() from
 * their base_init function to easily configure the set of caps/formats that
 * the element is able to handle.
 *
 * Derived classes should override the GstBase::AudioFilter::setup() and
 * Gst::BaseTransform::transform_ip() and/or Gst::BaseTransform::transform()
 * virtual functions in their class_init function.
 *
 * @ingroup GstBaseBaseClasses
 */

class AudioFilter : public Gst::BaseTransform
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef AudioFilter CppObjectType;
  typedef AudioFilter_Class CppClassType;
  typedef GstAudioFilter BaseObjectType;
  typedef GstAudioFilterClass BaseClassType;

private:  friend class AudioFilter_Class;
  static CppClassType audiofilter_class_;

private:
  // noncopyable
  AudioFilter(const AudioFilter&);
  AudioFilter& operator=(const AudioFilter&);

protected:
  explicit AudioFilter(const Glib::ConstructParams& construct_params);
  explicit AudioFilter(GstAudioFilter* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~AudioFilter();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstAudioFilter*       gobj()       { return reinterpret_cast<GstAudioFilter*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstAudioFilter* gobj() const { return reinterpret_cast<GstAudioFilter*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstAudioFilter* gobj_copy();

private:


public:
  //TODO: Wrap vfuncs.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace GstBase


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates GstBase::AudioFilter
   */
  Glib::RefPtr<GstBase::AudioFilter> wrap(GstAudioFilter* object, bool take_copy = false);
}


#endif /* _GSTREAMERBASEMM_AUDIOFILTER_H */

