// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERBASEMM_AUDIOSRC_H
#define _GSTREAMERBASEMM_AUDIOSRC_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include <gst/audio/gstaudiosrc.h>
#include <gstreamerbasemm/baseaudiosrc.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstAudioSrc GstAudioSrc;
typedef struct _GstAudioSrcClass GstAudioSrcClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace GstBase
{ class AudioSrc_Class; } // namespace GstBase
namespace GstBase
{

/** GstBase::AudioSrc — Simple base class for audio sources.
 * This is the most simple base class for audio sources that only requires
 * subclasses to implement a set of simple virtual functions:
 *
 * - open_vfunc() - Open the device.
 * - prepare_vfunc()  - Configure the device with the specified format.
 * - write_vfunc() - Write samples to the device.
 * - reset_vfunc() - Unblock writes and flush the device.
 * - delay_vfunc() - Get the number of samples written but not yet played by
 * the device.
 * - unprepare_vfunc() - Undo operations done by prepare.
 * - close_vfunc() - Close the device.
 *
 * All scheduling of samples and timestamps is done in this base class together
 * with GstBase::BaseAudioSrc using a default implementation of a
 * GstBase::RingBuffer that uses threads.
 *
 * Last reviewed on 2006-09-27 (0.10.12)
 *
 * @ingroup GstBaseBaseClasses
 */

class AudioSrc : public GstBase::BaseAudioSrc
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef AudioSrc CppObjectType;
  typedef AudioSrc_Class CppClassType;
  typedef GstAudioSrc BaseObjectType;
  typedef GstAudioSrcClass BaseClassType;

private:  friend class AudioSrc_Class;
  static CppClassType audiosrc_class_;

private:
  // noncopyable
  AudioSrc(const AudioSrc&);
  AudioSrc& operator=(const AudioSrc&);

protected:
  explicit AudioSrc(const Glib::ConstructParams& construct_params);
  explicit AudioSrc(GstAudioSrc* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~AudioSrc();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstAudioSrc*       gobj()       { return reinterpret_cast<GstAudioSrc*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstAudioSrc* gobj() const { return reinterpret_cast<GstAudioSrc*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstAudioSrc* gobj_copy();

private:


public:
  //TODO: Wrap vfuncs.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace GstBase


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates GstBase::AudioSrc
   */
  Glib::RefPtr<GstBase::AudioSrc> wrap(GstAudioSrc* object, bool take_copy = false);
}


#endif /* _GSTREAMERBASEMM_AUDIOSRC_H */

