// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERBASEMM_BASEAUDIOSINK_H
#define _GSTREAMERBASEMM_BASEAUDIOSINK_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gstreamermm/basesink.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstBaseAudioSink GstBaseAudioSink;
typedef struct _GstBaseAudioSinkClass GstBaseAudioSinkClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace GstBase
{ class BaseAudioSink_Class; } // namespace GstBase
namespace GstBase
{

//TODO: Enum is not registered nor does it have a *_get_type() functions.  See
//bug #564200.
//_WRAP_ENUM(BaseAudioSinkSlaveMethod, GstBaseAudioSinkSlaveMethod)

/** GstBase::BaseAudioSink — Base class for audio sinks.
 * This is the base class for audio sinks. Subclasses need to implement the
 * create_ringbuffer_vfunc vmethod. This base class will then take care of
 * writing samples to the ringbuffer, synchronisation, clipping and flushing.
 *
 * Last reviewed on 2006-09-27 (0.10.12).
 *
 * @ingroup GstBaseBaseClasses
 */

class BaseAudioSink : public Gst::BaseSink
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef BaseAudioSink CppObjectType;
  typedef BaseAudioSink_Class CppClassType;
  typedef GstBaseAudioSink BaseObjectType;
  typedef GstBaseAudioSinkClass BaseClassType;

private:  friend class BaseAudioSink_Class;
  static CppClassType baseaudiosink_class_;

private:
  // noncopyable
  BaseAudioSink(const BaseAudioSink&);
  BaseAudioSink& operator=(const BaseAudioSink&);

protected:
  explicit BaseAudioSink(const Glib::ConstructParams& construct_params);
  explicit BaseAudioSink(GstBaseAudioSink* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~BaseAudioSink();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstBaseAudioSink*       gobj()       { return reinterpret_cast<GstBaseAudioSink*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstBaseAudioSink* gobj() const { return reinterpret_cast<GstBaseAudioSink*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstBaseAudioSink* gobj_copy();

private:


public:
  /** Get the Gst::Clock of the GstBase::BaseAudioSink.
   */
   Glib::RefPtr<Gst::Clock> get_provided_clock() const;
 
  //TODO: _WRAP_METHOD(Glib::RefPtr<GstBase::RingBuffer> create_ring_buffer(), gst_base_audio_sink_create_ringbuffer)

  
  /** Controls whether @a sink will provide a clock or not. If @a provide is <tt>true</tt>, 
   * gst_element_provide_clock() will return a clock that reflects the datarate
   * of @a sink. If @a provide is <tt>false</tt>, gst_element_provide_clock() will return <tt>0</tt>.
   * 
   * Since: 0.10.16
   * @param provide New state.
   */
  void set_provide_clock(bool provide);
  
  /** Queries whether @a sink will provide a clock or not. See also
   * gst_base_audio_sink_set_provide_clock.
   * @return <tt>true</tt> if @a sink will provide a clock.
   * 
   * Since: 0.10.16.
   */
  bool get_provide_clock();

  //TODO: Following methods depend on enum above (see bug #564200)
  //_WRAP_METHOD(void set_slave_method(GstBaseAudioSinkSlaveMethod method), gst_base_audio_sink_set_slave_method)
  //WRAP_METHOD(BaseAudioSinkSlaveMethod get_slave_method(),gst_base_audio_sink_get_slave_method)

  //TODO: Wrap vfuncs.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace GstBase


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates GstBase::BaseAudioSink
   */
  Glib::RefPtr<GstBase::BaseAudioSink> wrap(GstBaseAudioSink* object, bool take_copy = false);
}


#endif /* _GSTREAMERBASEMM_BASEAUDIOSINK_H */

