// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERBASEMM_CDDABASESRC_H
#define _GSTREAMERBASEMM_CDDABASESRC_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include <gst/cdda/gstcddabasesrc.h>
#include <gstreamermm/pushsrc.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstCddaBaseSrc GstCddaBaseSrc;
typedef struct _GstCddaBaseSrcClass GstCddaBaseSrcClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace GstBase
{ class CddaBaseSrc_Class; } // namespace GstBase
namespace GstBase
{

//TODO: File a bug about enum not public:
//_WRAP_ENUM(CddaBaseSrcMode,GstCddaBaseSrcMode)

/** GstBase::CddaBaseSrc — Base class for CD digital audio (CDDA) sources.
 * Provides a base class for CDDA sources, which handles things like seeking,
 * querying, discid calculation, tags, and buffer timestamping.
 *
 * GstBase::CddaBaseSrc registers two Gst::Formats of its own, namely the
 * "track" format and the "sector" format. Applications will usually only find
 * the "track" format interesting. You can retrieve that Gst::Format for use in
 * seek events or queries with Gst::get_format("track").
 *
 * In order to query the number of tracks, for example, an application would
 * set the CDDA source element to READY or PAUSED state and then query the the
 * number of tracks via Gst::Element::query_duration() using the track format
 * acquired above. Applications can query the currently playing track in the
 * same way.
 *
 * Alternatively, applications may retrieve the currently playing track and the
 * total number of tracks from the taglist that will be posted on the bus
 * whenever the CD is opened or the currently playing track changes. The
 * taglist will contain Gst::Tag::TRACK_NUMBER and Gst::Tag::TRACK_COUNT tags.
 *
 * Applications playing back CD audio using playbin and cdda://n URIs should
 * issue a seek command in track format to change between tracks, rather than
 * setting a new cdda://n+1 URI on playbin (as setting a new URI on playbin
 * involves closing and re-opening the CD device, which is much much slower).
 *
 * CDDA sources will automatically emit a number of tags, details about which
 * can be found in the libgsttag documentation. Those tags are:
 * Gst::Tag::CDDA_CDDB_DISCID, Gst::Tag::CDDA_CDDB_DISCID_FULL,
 * Gst::Tag::CDDA_MUSICBRAINZ_DISCID, Gst::Tag::CDDA_MUSICBRAINZ_DISCID_FULL,
 * among others.
 *
 * @ingroup GstBaseBaseClasses
 */

class CddaBaseSrc : public Gst::PushSrc
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef CddaBaseSrc CppObjectType;
  typedef CddaBaseSrc_Class CppClassType;
  typedef GstCddaBaseSrc BaseObjectType;
  typedef GstCddaBaseSrcClass BaseClassType;

private:  friend class CddaBaseSrc_Class;
  static CppClassType cddabasesrc_class_;

private:
  // noncopyable
  CddaBaseSrc(const CddaBaseSrc&);
  CddaBaseSrc& operator=(const CddaBaseSrc&);

protected:
  explicit CddaBaseSrc(const Glib::ConstructParams& construct_params);
  explicit CddaBaseSrc(GstCddaBaseSrc* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~CddaBaseSrc();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstCddaBaseSrc*       gobj()       { return reinterpret_cast<GstCddaBaseSrc*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstCddaBaseSrc* gobj() const { return reinterpret_cast<GstCddaBaseSrc*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstCddaBaseSrc* gobj_copy();

private:


public:
  //TODO: _WRAP_METHOD(bool add_track(...), gst_cdda_base_src_add_track)
  //TODO: Wrap vfuncs.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace GstBase


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates GstBase::CddaBaseSrc
   */
  Glib::RefPtr<GstBase::CddaBaseSrc> wrap(GstCddaBaseSrc* object, bool take_copy = false);
}


#endif /* _GSTREAMERBASEMM_CDDABASESRC_H */

