// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GSTREAMERBASEMM_VIDEOSINK_H
#define _GSTREAMERBASEMM_VIDEOSINK_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* gstreamermm - a C++ wrapper for gstreamer
 *
 * Copyright 2008 The gstreamermm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gstreamermm/basesink.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GstVideoSink GstVideoSink;
typedef struct _GstVideoSinkClass GstVideoSinkClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace GstBase
{ class VideoSink_Class; } // namespace GstBase
namespace GstBase
{

/** GstBase::VideoSink — Base class for video sinks.
 * Provides useful functions and a base class for video sinks.
 *
 * GstBase::VideoSink will configure the default base sink to drop frames that
 * arrive later than 20ms as this is considered the default threshold for
 * observing out-of-sync frames. 
 *
 * @ingroup GstBaseBaseClasses
 */

class VideoSink : public Gst::BaseSink
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef VideoSink CppObjectType;
  typedef VideoSink_Class CppClassType;
  typedef GstVideoSink BaseObjectType;
  typedef GstVideoSinkClass BaseClassType;

private:  friend class VideoSink_Class;
  static CppClassType videosink_class_;

private:
  // noncopyable
  VideoSink(const VideoSink&);
  VideoSink& operator=(const VideoSink&);

protected:
  explicit VideoSink(const Glib::ConstructParams& construct_params);
  explicit VideoSink(GstVideoSink* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~VideoSink();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GstVideoSink*       gobj()       { return reinterpret_cast<GstVideoSink*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GstVideoSink* gobj() const { return reinterpret_cast<GstVideoSink*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GstVideoSink* gobj_copy();

private:


public:
  /** Get height of GstBase::VideoSink.
   */
   int get_height() const;
 
  /** Get width of GstBase::VideoSink.
   */
   int get_width() const;
 
  //TODO: _WRAP_METHOD(void center_rect(...), gst_video_sink_center_rect)


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace GstBase


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates GstBase::VideoSink
   */
  Glib::RefPtr<GstBase::VideoSink> wrap(GstVideoSink* object, bool take_copy = false);
}


#endif /* _GSTREAMERBASEMM_VIDEOSINK_H */

