
#include <glib.h>

// Disable the 'const' function attribute of the get_type() functions.
// GCC would optimize them out because we don't use the return value.
#undef  G_GNUC_CONST
#define G_GNUC_CONST /* empty */

#include <gstreamerbasemm/wrap_init.h>
#include <glibmm/error.h>
#include <glibmm/object.h>

// #include the widget headers so that we can call the get_type() static methods:

#include "audioclock.h"
#include "audiofilter.h"
#include "audiosink.h"
#include "audiosrc.h"
#include "baseaudiosink.h"
#include "baseaudiosrc.h"
#include "cddabasesrc.h"
#include "videosink.h"
#include "colorbalance.h"
#include "colorbalancechannel.h"
#include "xoverlay.h"
#include "adder.h"
#include "alsamixer.h"
#include "alsasink.h"
#include "alsasrc.h"
#include "audioconvert.h"
#include "audioresample.h"
#include "audiotestsrc.h"
#include "cdparanoiasrc.h"
#include "clockoverlay.h"
#include "decodebin.h"
#include "ffmpegcolorspace.h"
#include "giosink.h"
#include "giosrc.h"
#include "giostreamsink.h"
#include "giostreamsrc.h"
#include "oggdemux.h"
#include "oggmux.h"
#include "playbin2.h"
#include "textoverlay.h"
#include "textrender.h"
#include "theoradec.h"
#include "theoraenc.h"
#include "timeoverlay.h"
#include "videorate.h"
#include "videoscale.h"
#include "videotestsrc.h"
#include "volume.h"
#include "vorbisdec.h"
#include "vorbisenc.h"
#include "vorbisparse.h"
#include "vorbistag.h"
#include "ximagesink.h"
#include "xvimagesink.h"

extern "C"
{

//Declarations of the *_get_type() functions:

GType gst_adder_get_type(void);
GType gst_alsa_mixer_element_get_type(void);
GType gst_alsa_sink_get_type(void);
GType gst_alsa_src_get_type(void);
GType gst_audio_clock_get_type(void);
GType gst_audio_convert_get_type(void);
GType gst_audio_filter_get_type(void);
GType gst_audioresample_get_type(void);
GType gst_audio_sink_get_type(void);
GType gst_audio_src_get_type(void);
GType gst_audio_test_src_get_type(void);
GType gst_base_audio_sink_get_type(void);
GType gst_base_audio_src_get_type(void);
GType gst_cd_paranoia_src_get_type(void);
GType gst_cdda_base_src_get_type(void);
GType gst_clock_overlay_get_type(void);
GType gst_color_balance_channel_get_type(void);
GType gst_decode_bin_get_type(void);
GType gst_ff_mpeg_csp_get_type(void);
GType gst_gio_sink_get_type(void);
GType gst_gio_src_get_type(void);
GType gst_gio_stream_sink_get_type(void);
GType gst_gio_stream_src_get_type(void);
GType gst_ogg_demux_get_type(void);
GType gst_ogg_mux_get_type(void);
GType gst_play_bin2_get_type(void);
GType gst_text_overlay_get_type(void);
GType gst_text_render_get_type(void);
GType gst_theora_dec_get_type(void);
GType gst_theora_enc_get_type(void);
GType gst_time_overlay_get_type(void);
GType gst_video_rate_get_type(void);
GType gst_video_scale_get_type(void);
GType gst_video_sink_get_type(void);
GType gst_video_test_src_get_type(void);
GType gst_volume_get_type(void);
GType gst_vorbis_dec_get_type(void);
GType gst_vorbis_enc_get_type(void);
GType gst_vorbis_parse_get_type(void);
GType gst_vorbis_tag_get_type(void);
GType gst_ximage_sink_get_type(void);
GType gst_xv_image_sink_get_type(void);

//Declarations of the *_error_quark() functions:

} // extern "C"


//Declarations of the *_Class::wrap_new() methods, instead of including all the private headers:

namespace GstBase {  class Adder_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AlsaMixer_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AlsaSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AlsaSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioClock_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioConvert_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioFilter_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioResample_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class AudioTestSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class BaseAudioSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class BaseAudioSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class CdParanoiaSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class CddaBaseSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class ClockOverlay_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class ColorBalanceChannel_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class DecodeBin_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class FfmpegColorSpace_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class GioSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class GioSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class GioStreamSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class GioStreamSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class OggDemux_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class OggMux_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class PlayBin2_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class TextOverlay_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class TextRender_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class TheoraDec_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class TheoraEnc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class TimeOverlay_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VideoRate_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VideoScale_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VideoSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VideoTestSrc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class Volume_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VorbisDec_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VorbisEnc_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VorbisParse_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class VorbisTag_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class XImageSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }
namespace GstBase {  class XvImageSink_Class { public: static Glib::ObjectBase* wrap_new(GObject*); };  }

namespace GstBase { 

void wrap_init()
{
  // Register Error domains:

// Map gtypes to gtkmm wrapper-creation functions:
  Glib::wrap_register(gst_adder_get_type(), &GstBase::Adder_Class::wrap_new);
  Glib::wrap_register(gst_alsa_mixer_element_get_type(), &GstBase::AlsaMixer_Class::wrap_new);
  Glib::wrap_register(gst_alsa_sink_get_type(), &GstBase::AlsaSink_Class::wrap_new);
  Glib::wrap_register(gst_alsa_src_get_type(), &GstBase::AlsaSrc_Class::wrap_new);
  Glib::wrap_register(gst_audio_clock_get_type(), &GstBase::AudioClock_Class::wrap_new);
  Glib::wrap_register(gst_audio_convert_get_type(), &GstBase::AudioConvert_Class::wrap_new);
  Glib::wrap_register(gst_audio_filter_get_type(), &GstBase::AudioFilter_Class::wrap_new);
  Glib::wrap_register(gst_audioresample_get_type(), &GstBase::AudioResample_Class::wrap_new);
  Glib::wrap_register(gst_audio_sink_get_type(), &GstBase::AudioSink_Class::wrap_new);
  Glib::wrap_register(gst_audio_src_get_type(), &GstBase::AudioSrc_Class::wrap_new);
  Glib::wrap_register(gst_audio_test_src_get_type(), &GstBase::AudioTestSrc_Class::wrap_new);
  Glib::wrap_register(gst_base_audio_sink_get_type(), &GstBase::BaseAudioSink_Class::wrap_new);
  Glib::wrap_register(gst_base_audio_src_get_type(), &GstBase::BaseAudioSrc_Class::wrap_new);
  Glib::wrap_register(gst_cd_paranoia_src_get_type(), &GstBase::CdParanoiaSrc_Class::wrap_new);
  Glib::wrap_register(gst_cdda_base_src_get_type(), &GstBase::CddaBaseSrc_Class::wrap_new);
  Glib::wrap_register(gst_clock_overlay_get_type(), &GstBase::ClockOverlay_Class::wrap_new);
  Glib::wrap_register(gst_color_balance_channel_get_type(), &GstBase::ColorBalanceChannel_Class::wrap_new);
  Glib::wrap_register(gst_decode_bin_get_type(), &GstBase::DecodeBin_Class::wrap_new);
  Glib::wrap_register(gst_ff_mpeg_csp_get_type(), &GstBase::FfmpegColorSpace_Class::wrap_new);
  Glib::wrap_register(gst_gio_sink_get_type(), &GstBase::GioSink_Class::wrap_new);
  Glib::wrap_register(gst_gio_src_get_type(), &GstBase::GioSrc_Class::wrap_new);
  Glib::wrap_register(gst_gio_stream_sink_get_type(), &GstBase::GioStreamSink_Class::wrap_new);
  Glib::wrap_register(gst_gio_stream_src_get_type(), &GstBase::GioStreamSrc_Class::wrap_new);
  Glib::wrap_register(gst_ogg_demux_get_type(), &GstBase::OggDemux_Class::wrap_new);
  Glib::wrap_register(gst_ogg_mux_get_type(), &GstBase::OggMux_Class::wrap_new);
  Glib::wrap_register(gst_play_bin2_get_type(), &GstBase::PlayBin2_Class::wrap_new);
  Glib::wrap_register(gst_text_overlay_get_type(), &GstBase::TextOverlay_Class::wrap_new);
  Glib::wrap_register(gst_text_render_get_type(), &GstBase::TextRender_Class::wrap_new);
  Glib::wrap_register(gst_theora_dec_get_type(), &GstBase::TheoraDec_Class::wrap_new);
  Glib::wrap_register(gst_theora_enc_get_type(), &GstBase::TheoraEnc_Class::wrap_new);
  Glib::wrap_register(gst_time_overlay_get_type(), &GstBase::TimeOverlay_Class::wrap_new);
  Glib::wrap_register(gst_video_rate_get_type(), &GstBase::VideoRate_Class::wrap_new);
  Glib::wrap_register(gst_video_scale_get_type(), &GstBase::VideoScale_Class::wrap_new);
  Glib::wrap_register(gst_video_sink_get_type(), &GstBase::VideoSink_Class::wrap_new);
  Glib::wrap_register(gst_video_test_src_get_type(), &GstBase::VideoTestSrc_Class::wrap_new);
  Glib::wrap_register(gst_volume_get_type(), &GstBase::Volume_Class::wrap_new);
  Glib::wrap_register(gst_vorbis_dec_get_type(), &GstBase::VorbisDec_Class::wrap_new);
  Glib::wrap_register(gst_vorbis_enc_get_type(), &GstBase::VorbisEnc_Class::wrap_new);
  Glib::wrap_register(gst_vorbis_parse_get_type(), &GstBase::VorbisParse_Class::wrap_new);
  Glib::wrap_register(gst_vorbis_tag_get_type(), &GstBase::VorbisTag_Class::wrap_new);
  Glib::wrap_register(gst_ximage_sink_get_type(), &GstBase::XImageSink_Class::wrap_new);
  Glib::wrap_register(gst_xv_image_sink_get_type(), &GstBase::XvImageSink_Class::wrap_new);

  // Register the gtkmm gtypes:
  GstBase::Adder::get_type();
  GstBase::AlsaMixer::get_type();
  GstBase::AlsaSink::get_type();
  GstBase::AlsaSrc::get_type();
  GstBase::AudioClock::get_type();
  GstBase::AudioConvert::get_type();
  GstBase::AudioFilter::get_type();
  GstBase::AudioResample::get_type();
  GstBase::AudioSink::get_type();
  GstBase::AudioSrc::get_type();
  GstBase::AudioTestSrc::get_type();
  GstBase::BaseAudioSink::get_type();
  GstBase::BaseAudioSrc::get_type();
  GstBase::CdParanoiaSrc::get_type();
  GstBase::CddaBaseSrc::get_type();
  GstBase::ClockOverlay::get_type();
  GstBase::ColorBalanceChannel::get_type();
  GstBase::DecodeBin::get_type();
  GstBase::FfmpegColorSpace::get_type();
  GstBase::GioSink::get_type();
  GstBase::GioSrc::get_type();
  GstBase::GioStreamSink::get_type();
  GstBase::GioStreamSrc::get_type();
  GstBase::OggDemux::get_type();
  GstBase::OggMux::get_type();
  GstBase::PlayBin2::get_type();
  GstBase::TextOverlay::get_type();
  GstBase::TextRender::get_type();
  GstBase::TheoraDec::get_type();
  GstBase::TheoraEnc::get_type();
  GstBase::TimeOverlay::get_type();
  GstBase::VideoRate::get_type();
  GstBase::VideoScale::get_type();
  GstBase::VideoSink::get_type();
  GstBase::VideoTestSrc::get_type();
  GstBase::Volume::get_type();
  GstBase::VorbisDec::get_type();
  GstBase::VorbisEnc::get_type();
  GstBase::VorbisParse::get_type();
  GstBase::VorbisTag::get_type();
  GstBase::XImageSink::get_type();
  GstBase::XvImageSink::get_type();

} // wrap_init()

} //GstBase


